"""Dispatch report requested by the user"""
import logging
from typing import Dict

from ws_metrics.reporting.generate_report import Report

from ws_metrics.enums import ReportEnum


class DispatchReports:
    def __init__(self):
        self.logger = logging.getLogger("ws_metrics")

    def write_report(self, report_type: ReportEnum, data: Dict) -> Report:
        self.logger.info(f"Rendering {report_type} ...")
        return report_type.template_type.render_report_template(data)

    def dispatch_file_to_user(self, report: Report):
        self.logger.info(f"Writing {ReportEnum(report.type).title} to file...")
        data = {}
        r = open(report.name, "w")
        r.write(self.write_report(report, data).content)
        r.close()

    def dispatch_data_to_terminal(self, report: Report):
        pass
