# Building/Deploying the `ingest` PEX
1. SSH into shipman using your user account with: `ssh shipman`
2. If you have a workspaces repo cloned in your home directory, continue onto step 3. If not, clone it using: `git clone https://gitlab.nrao.edu/ssa/workspaces.git`. It may ask for your GitLab credentials. Enter them.
3. `cd workspaces/apps/cli/executables/pexables/ingest`
4. If there's a `venv` directory in this directory, continue to step 4. If not, complete step 3.1.
   1. Create a Python virtual environment with `/home/ssa/bin/python3.8 -m venv venv`
5. Install `ingest`'s dependencies with `./venv/bin/python3 setup.py develop`
6. Re-install `pex` using `./venv/bin/pip install -I pex==2.1.43`
7. Now build and deploy the PEX using the following command:
```bash
./venv/bin/python3 setup.py bdist_pex --bdist-all --bdist-dir="/lustre/aoc/cluster/pipeline/dsoc-dev/workspaces/sbin/" --pex-args="--python-shebang /home/ssa/bin/python3.8"
```

The PEX should build without any issues and be deployed to the dev SBIN area on lustre.

## Copy `ingest` PEX over to test
```bash
cp /lustre/aoc/cluster/pipeline/dsoc-dev/workspaces/sbin/ingest /lustre/aoc/cluster/pipeline/dsoc-test/workspaces/sbin/ingest
```

## Copy `ingest` PEX over to prod
```bash
cp /lustre/aoc/cluster/pipeline/dsoc-dev/workspaces/sbin/ingest /lustre/aoc/cluster/pipeline/dsoc-prod/workspaces/sbin/ingest
```
